// This is the C source file.  It contains callers that invoke the various
// functions of the kernel extensions you are using.  Be sure to #include
// this file in one of your source files preceded by library.h.  Also #include
// library.h in any other source files that use routines of the kernel
// extensions.

#pragma option nowarn=par
#pragma option nowarn=rvl
#pragma option macro=yes    // Turn on #define to equ translation
// ----Beginning of package memory allocation listing----
// Package GUI_Toolkit_QSC_v1.92  Code: 070000 - 07345a Vars: 008e00 - 008e0a
// Package EtherWiFi_v2.3         Code: 0d0000 - 0d646e Vars: 008e0c - 008e64
// ----End of package memory allocation listing----

// Beginning C Source file for package: EtherWiFi

_forth  void Cat (xaddr countedLStrAddr, uint maxChars, xaddr strToAdd, int cntToAdd, uint eol)
{
#asm
    dey
    dey
    dey
    dey
    ldx #CAT_ADDR
    stx 2,y
    ldx #CAT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_at(ether_revector_module_XADDR)  int ether_revector_module;

_at(ether_service_module_XADDR)  int ether_service_module;

_at(ether_command_XADDR)  ulong ether_command;

_at(ether_response_XADDR)  ulong ether_response;

_at(ether_gui_message_XADDR)  ulong ether_gui_message;

_forth  void WiFi_Module ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_MODULE_ADDR
    stx 2,y
    ldx #WIFI_MODULE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr Ether_Info ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_INFO_ADDR
    stx 2,y
    ldx #ETHER_INFO_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int WiFi_Check ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_CHECK_ADDR
    stx 2,y
    ldx #WIFI_CHECK_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr Ether_My_IP_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_MY_IP_PTR_ADDR
    stx 2,y
    ldx #ETHER_MY_IP_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr Ether_Gateway_IP_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_GATEWAY_IP_PTR_ADDR
    stx 2,y
    ldx #ETHER_GATEWAY_IP_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr Ether_Netmask_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_NETMASK_PTR_ADDR
    stx 2,y
    ldx #ETHER_NETMASK_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr Ether_Inbuf ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_INBUF_ADDR
    stx 2,y
    ldx #ETHER_INBUF_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr Ether_Outbuf ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_OUTBUF_ADDR
    stx 2,y
    ldx #ETHER_OUTBUF_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint Ether_Outbufsize ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_OUTBUFSIZE_ADDR
    stx 2,y
    ldx #ETHER_OUTBUFSIZE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint Ether_Inbufsize ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_INBUFSIZE_ADDR
    stx 2,y
    ldx #ETHER_INBUFSIZE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Set_Inbuf ( xaddr bufbase, int maxnumbytes, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SET_INBUF_ADDR
    stx 2,y
    ldx #ETHER_SET_INBUF_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Set_Outbuf ( xaddr xbufbase, int maxnumbytes, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SET_OUTBUF_ADDR
    stx 2,y
    ldx #ETHER_SET_OUTBUF_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Inbuf ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_INBUF_ADDR
    stx 2,y
    ldx #HTTP_INBUF_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Outbuf ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_OUTBUF_ADDR
    stx 2,y
    ldx #HTTP_OUTBUF_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint HTTP_Outbufsize ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_OUTBUFSIZE_ADDR
    stx 2,y
    ldx #HTTP_OUTBUFSIZE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint HTTP_Inbufsize ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_INBUFSIZE_ADDR
    stx 2,y
    ldx #HTTP_INBUFSIZE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Set_Inbuf ( xaddr xbufbase, int maxnumbytes, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_SET_INBUF_ADDR
    stx 2,y
    ldx #HTTP_SET_INBUF_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Set_Outbuf ( xaddr bufbase, int maxnumbytes, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_SET_OUTBUF_ADDR
    stx 2,y
    ldx #HTTP_SET_OUTBUF_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint Ether_Error ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_ERROR_ADDR
    stx 2,y
    ldx #ETHER_ERROR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Error_Clear ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_ERROR_CLEAR_ADDR
    stx 2,y
    ldx #ETHER_ERROR_CLEAR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Enable_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_ENABLE_PTR_ADDR
    stx 2,y
    ldx #HTTP_ENABLE_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr Ether_Tunnel_Enable_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_TUNNEL_ENABLE_PTR_ADDR
    stx 2,y
    ldx #ETHER_TUNNEL_ENABLE_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint HTTP_Numbytes_Sent ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_NUMBYTES_SENT_ADDR
    stx 2,y
    ldx #HTTP_NUMBYTES_SENT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Status_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_STATUS_PTR_ADDR
    stx 2,y
    ldx #HTTP_STATUS_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Timeout_Msec_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_TIMEOUT_MSEC_PTR_ADDR
    stx 2,y
    ldx #HTTP_TIMEOUT_MSEC_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Get_Timeout_Msec_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_GET_TIMEOUT_MSEC_PTR_ADDR
    stx 2,y
    ldx #HTTP_GET_TIMEOUT_MSEC_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Index_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_INDEX_PTR_ADDR
    stx 2,y
    ldx #HTTP_INDEX_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Is_Autoserve_Array ( xaddr xarraybase, int numrows, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_IS_AUTOSERVE_ARRAY_ADDR
    stx 2,y
    ldx #HTTP_IS_AUTOSERVE_ARRAY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Autoserve_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_AUTOSERVE_PTR_ADDR
    stx 2,y
    ldx #HTTP_AUTOSERVE_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Default_Handler_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_DEFAULT_HANDLER_PTR_ADDR
    stx 2,y
    ldx #HTTP_DEFAULT_HANDLER_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_URL_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_URL_PTR_ADDR
    stx 2,y
    ldx #HTTP_URL_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int HTTP_URL_Full_Count ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_URL_FULL_COUNT_ADDR
    stx 2,y
    ldx #HTTP_URL_FULL_COUNT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int HTTP_URL_Base_Count ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_URL_BASE_COUNT_ADDR
    stx 2,y
    ldx #HTTP_URL_BASE_COUNT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Local_IP ( char ip1, char ip2, char ip3, char ip4, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_LOCAL_IP_ADDR
    stx 2,y
    ldx #ETHER_LOCAL_IP_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Local_Port ( int portnum, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_LOCAL_PORT_ADDR
    stx 2,y
    ldx #ETHER_LOCAL_PORT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Internal_Webserver_Port ( int portnum, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_INTERNAL_WEBSERVER_PORT_ADDR
    stx 2,y
    ldx #ETHER_INTERNAL_WEBSERVER_PORT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Gateway ( char ip1,char ip2,char ip3,char ip4, int subnet_bits, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_GATEWAY_ADDR
    stx 2,y
    ldx #ETHER_GATEWAY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr Ether_Remote_IP_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_REMOTE_IP_PTR_ADDR
    stx 2,y
    ldx #ETHER_REMOTE_IP_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr Ether_Remote_Port_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_REMOTE_PORT_PTR_ADDR
    stx 2,y
    ldx #ETHER_REMOTE_PORT_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_DHCP_Name ( xaddr xname_string, int name_cnt, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_DHCP_NAME_ADDR
    stx 2,y
    ldx #ETHER_DHCP_NAME_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Telnet_Password ( xaddr xpassword_string, int password_cnt, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_TELNET_PASSWORD_ADDR
    stx 2,y
    ldx #ETHER_TELNET_PASSWORD_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_TCP_Control ( char keepalive_sec, char discon_minutes, int send_imm_chars, char flushmode, char packing, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_TCP_CONTROL_ADDR
    stx 2,y
    ldx #ETHER_TCP_CONTROL_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void WiFi_Security ( int authenticate_flag, int suite_method, int pairwise_encrypt_method,	int group_encrypt_method, int key_length, int passphrase_flag, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_SECURITY_ADDR
    stx 2,y
    ldx #WIFI_SECURITY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void WiFi_SSID ( xaddr ssid_buffer_xbase, int count, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_SSID_ADDR
    stx 2,y
    ldx #WIFI_SSID_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void WiFi_Options ( int tx_power_level, int tx_power_manager_flag, int tx_rate, int tx_auto_rate_flag, int adhoc_flag, int adhoc_chan, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_OPTIONS_ADDR
    stx 2,y
    ldx #WIFI_OPTIONS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Emit ( uchar character,  int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_EMIT_ADDR
    stx 2,y
    ldx #ETHER_EMIT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Ether_Ask_Emit ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_ASK_EMIT_ADDR
    stx 2,y
    ldx #ETHER_ASK_EMIT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Ether_Ask_Key ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_ASK_KEY_ADDR
    stx 2,y
    ldx #ETHER_ASK_KEY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uchar Ether_Key ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_KEY_ADDR
    stx 2,y
    ldx #ETHER_KEY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uchar Ether_ASCII_Key ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_ASCII_KEY_ADDR
    stx 2,y
    ldx #ETHER_ASCII_KEY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void E_Emit ( uchar character )
{
#asm
    dey
    dey
    dey
    dey
    ldx #E_EMIT_ADDR
    stx 2,y
    ldx #E_EMIT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int E_Ask_Key ( void )
{
#asm
    dey
    dey
    dey
    dey
    ldx #E_ASK_KEY_ADDR
    stx 2,y
    ldx #E_ASK_KEY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uchar E_Key ( void )
{
#asm
    dey
    dey
    dey
    dey
    ldx #E_KEY_ADDR
    stx 2,y
    ldx #E_KEY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uchar E_ASCII_Key ( void )
{
#asm
    dey
    dey
    dey
    dey
    ldx #E_ASCII_KEY_ADDR
    stx 2,y
    ldx #E_ASCII_KEY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Outbuf_Cat ( xaddr xstring, uint count, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_OUTBUF_CAT_ADDR
    stx 2,y
    ldx #ETHER_OUTBUF_CAT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Outbuf_Cat ( xaddr xstring, uint count, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_OUTBUF_CAT_ADDR
    stx 2,y
    ldx #HTTP_OUTBUF_CAT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Shutdown ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SHUTDOWN_ADDR
    stx 2,y
    ldx #ETHER_SHUTDOWN_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Ether_Ready_For_Command ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_READY_FOR_COMMAND_ADDR
    stx 2,y
    ldx #ETHER_READY_FOR_COMMAND_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  ulong Ether_Await_Response ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_AWAIT_RESPONSE_ADDR
    stx 2,y
    ldx #ETHER_AWAIT_RESPONSE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  ulong Ether_Check_Response ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_CHECK_RESPONSE_ADDR
    stx 2,y
    ldx #ETHER_CHECK_RESPONSE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Ether_Connect_Status ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_CONNECT_STATUS_ADDR
    stx 2,y
    ldx #ETHER_CONNECT_STATUS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Ether_Passive_Non_Web_Connection ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_PASSIVE_NON_WEB_CONNECTION_ADDR
    stx 2,y
    ldx #ETHER_PASSIVE_NON_WEB_CONNECTION_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Ether_Disconnect_During_Send ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_DISCONNECT_DURING_SEND_ADDR
    stx 2,y
    ldx #ETHER_DISCONNECT_DURING_SEND_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Flush_NBytes ( uint maxbytes, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_FLUSH_NBYTES_ADDR
    stx 2,y
    ldx #ETHER_FLUSH_NBYTES_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Flush ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_FLUSH_ADDR
    stx 2,y
    ldx #ETHER_FLUSH_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Add_Data ( xaddr xlbuffer, uint maxbytes, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_ADD_DATA_ADDR
    stx 2,y
    ldx #ETHER_ADD_DATA_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Get_Data ( xaddr xlbuffer, uint maxbytes, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_GET_DATA_ADDR
    stx 2,y
    ldx #ETHER_GET_DATA_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Add_Chars ( xaddr xlbuffer, uint maxbytes, uint maxlines, char eol, int discard_alt_eol, int discard_msbit_set, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_ADD_CHARS_ADDR
    stx 2,y
    ldx #ETHER_ADD_CHARS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Get_Chars ( xaddr xlbuffer, uint maxbytes, uint maxlines, char eol, int discard_alt_eol, int discard_msbit_set, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_GET_CHARS_ADDR
    stx 2,y
    ldx #ETHER_GET_CHARS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Get_Line ( xaddr xlbuffer, uint maxbytes, char eol, int discard_alt_eol, int discard_msbit_set, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_GET_LINE_ADDR
    stx 2,y
    ldx #ETHER_GET_LINE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Add_Line ( xaddr xlbuffer, uint maxbytes, char eol, int discard_alt_eol, int discard_msbit_set, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_ADD_LINE_ADDR
    stx 2,y
    ldx #ETHER_ADD_LINE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Send_Buffer ( xaddr xbuffer, uint count, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SEND_BUFFER_ADDR
    stx 2,y
    ldx #ETHER_SEND_BUFFER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Send_LBuffer ( xaddr xlbuffer, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SEND_LBUFFER_ADDR
    stx 2,y
    ldx #ETHER_SEND_LBUFFER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Send_2Buffers ( xaddr xbuffer1, uint count1, xaddr xbuffer2, uint count2, uint timeout_msec, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SEND_2BUFFERS_ADDR
    stx 2,y
    ldx #ETHER_SEND_2BUFFERS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Ether_Encryption ( xaddr key_buffer_xbase, int num_key_bytes, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_ENCRYPTION_ADDR
    stx 2,y
    ldx #ETHER_ENCRYPTION_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int WiFi_Encryption_Key ( xaddr key_buffer_xbase, int num_key_bytes, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_ENCRYPTION_KEY_ADDR
    stx 2,y
    ldx #WIFI_ENCRYPTION_KEY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_XPort_Defaults ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_XPORT_DEFAULTS_ADDR
    stx 2,y
    ldx #ETHER_XPORT_DEFAULTS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_XPort_Update ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_XPORT_UPDATE_ADDR
    stx 2,y
    ldx #ETHER_XPORT_UPDATE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Ping_Request ( char ip1, char ip2, char ip3, char ip4, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_PING_REQUEST_ADDR
    stx 2,y
    ldx #ETHER_PING_REQUEST_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Ping_Report ( char ip1, char ip2, char ip3, char ip4, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_PING_REPORT_ADDR
    stx 2,y
    ldx #ETHER_PING_REPORT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_IP_Info_Request ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_IP_INFO_REQUEST_ADDR
    stx 2,y
    ldx #ETHER_IP_INFO_REQUEST_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_IP_Info_Report ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_IP_INFO_REPORT_ADDR
    stx 2,y
    ldx #ETHER_IP_INFO_REPORT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Disconnect ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_DISCONNECT_ADDR
    stx 2,y
    ldx #ETHER_DISCONNECT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Disconnect_Flush ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_DISCONNECT_FLUSH_ADDR
    stx 2,y
    ldx #ETHER_DISCONNECT_FLUSH_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Connect ( char ip1, char ip2, char ip3, char ip4, int port, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_CONNECT_ADDR
    stx 2,y
    ldx #ETHER_CONNECT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int HTTP_Add_Handler ( xaddr url_xstring, int url_count, xaddr (*handler_ptr)(void), int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_ADD_HANDLER_ADDR
    stx 2,y
    ldx #HTTP_ADD_HANDLER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int HTTP_Add_GUI_Handler ( xaddr url_xstring, int url_count, xaddr (*handler_ptr)(void), int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_ADD_GUI_HANDLER_ADDR
    stx 2,y
    ldx #HTTP_ADD_GUI_HANDLER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Fieldname_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_FIELDNAME_PTR_ADDR
    stx 2,y
    ldx #HTTP_FIELDNAME_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int HTTP_Fieldname_Count ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_FIELDNAME_COUNT_ADDR
    stx 2,y
    ldx #HTTP_FIELDNAME_COUNT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  xaddr HTTP_Value_Ptr ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_VALUE_PTR_ADDR
    stx 2,y
    ldx #HTTP_VALUE_PTR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int HTTP_Value_Count ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_VALUE_COUNT_ADDR
    stx 2,y
    ldx #HTTP_VALUE_COUNT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int HTTP_To_Next_Field ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_TO_NEXT_FIELD_ADDR
    stx 2,y
    ldx #HTTP_TO_NEXT_FIELD_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  TWO_INTS HTTP_Imagemap ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_IMAGEMAP_ADDR
    stx 2,y
    ldx #HTTP_IMAGEMAP_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Plus_To_Space ( xaddr xstring, int count )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_PLUS_TO_SPACE_ADDR
    stx 2,y
    ldx #HTTP_PLUS_TO_SPACE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int HTTP_Unescape ( xaddr xstring, int count )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_UNESCAPE_ADDR
    stx 2,y
    ldx #HTTP_UNESCAPE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Parse_URL ( xaddr xstring, int count, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_PARSE_URL_ADDR
    stx 2,y
    ldx #HTTP_PARSE_URL_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint HTTP_Send_Buffer ( xaddr xbuffer, uint count, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_SEND_BUFFER_ADDR
    stx 2,y
    ldx #HTTP_SEND_BUFFER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint HTTP_Send_LBuffer ( xaddr xlbuffer, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_SEND_LBUFFER_ADDR
    stx 2,y
    ldx #HTTP_SEND_LBUFFER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint HTTP_Send_2Buffers ( xaddr xbuffer1, uint count1, xaddr xbuffer2, uint count2,							int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_SEND_2BUFFERS_ADDR
    stx 2,y
    ldx #HTTP_SEND_2BUFFERS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_GUI_Send_Buffer ( xaddr xbuffer, uint count, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_GUI_SEND_BUFFER_ADDR
    stx 2,y
    ldx #HTTP_GUI_SEND_BUFFER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_GUI_Send_LBuffer ( xaddr xlbuffer, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_GUI_SEND_LBUFFER_ADDR
    stx 2,y
    ldx #HTTP_GUI_SEND_LBUFFER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_GUI_Send_2Buffers ( xaddr xbuffer1, uint count1, xaddr xbuffer2, uint count2, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_GUI_SEND_2BUFFERS_ADDR
    stx 2,y
    ldx #HTTP_GUI_SEND_2BUFFERS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Put_Header ( xaddr xlbuffer, uint bufsize )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_PUT_HEADER_ADDR
    stx 2,y
    ldx #HTTP_PUT_HEADER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Put_Content_Type ( xaddr xlbuffer, uint bufsize, int dynamic, int content_type )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_PUT_CONTENT_TYPE_ADDR
    stx 2,y
    ldx #HTTP_PUT_CONTENT_TYPE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Default_Handler ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_DEFAULT_HANDLER_ADDR
    stx 2,y
    ldx #HTTP_DEFAULT_HANDLER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void HTTP_Server ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HTTP_SERVER_ADDR
    stx 2,y
    ldx #HTTP_SERVER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Ether_Check_GUI ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_CHECK_GUI_ADDR
    stx 2,y
    ldx #ETHER_CHECK_GUI_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Send_Email ( xaddr xemail_body,uint bodycnt,xaddr xhost,int hostcnt, xaddr xsender,int sendercnt,xaddr xrcvr, int rcvrcnt,xaddr xscratchbuf, char dest_ip1,char ip2,char ip3,char ip4,int destport,uint timeout_ms,int module)
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SEND_EMAIL_ADDR
    stx 2,y
    ldx #ETHER_SEND_EMAIL_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Ether_Info_Init ( xaddr xinfo,xaddr xautoserve,int numrows,xaddr xbuffer_area_base, xaddr xcmdmail,xaddr xresponsemail,xaddr xguimail,uint etherinbufsize, uint etheroutbufsize,uint httpinbufsize,uint httpoutbufsize,int modulenum)
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_INFO_INIT_ADDR
    stx 2,y
    ldx #ETHER_INFO_INIT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int WiFi_Info_Init ( xaddr xinfo,xaddr xautoserve,int numrows,xaddr xbuffer_area_base, xaddr xcmdmail,xaddr xresponsemail,xaddr xguimail,uint etherinbufsize, uint etheroutbufsize,uint httpinbufsize,uint httpoutbufsize,int modulenum)
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_INFO_INIT_ADDR
    stx 2,y
    ldx #WIFI_INFO_INIT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint Ether_Init ( xaddr xinfo,xaddr xautoserve,int numrows,xaddr xbuffer_area_base, xaddr xcmdmail,xaddr xresponsemail,xaddr xguimail,uint etherinbufsize, uint etheroutbufsize,uint httpinbufsize,uint httpoutbufsize,int modulenum)
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_INIT_ADDR
    stx 2,y
    ldx #ETHER_INIT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint WiFi_Init ( xaddr xinfo,xaddr xautoserve,int numrows,xaddr xbuffer_area_base, xaddr xcmdmail,xaddr xresponsemail,xaddr xguimail,uint etherinbufsize, uint etheroutbufsize,uint httpinbufsize,uint httpoutbufsize,int modulenum)
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_INIT_ADDR
    stx 2,y
    ldx #WIFI_INIT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint Ether_Setup ( xaddr xbuffer_area_base, addr mailbox_base, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SETUP_ADDR
    stx 2,y
    ldx #ETHER_SETUP_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint WiFi_Setup ( xaddr xbuffer_area_base, addr mailbox_base, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_SETUP_ADDR
    stx 2,y
    ldx #WIFI_SETUP_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint Ether_Setup_Default ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SETUP_DEFAULT_ADDR
    stx 2,y
    ldx #ETHER_SETUP_DEFAULT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  uint WiFi_Setup_Default ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_SETUP_DEFAULT_ADDR
    stx 2,y
    ldx #WIFI_SETUP_DEFAULT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Command_Manager ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_COMMAND_MANAGER_ADDR
    stx 2,y
    ldx #ETHER_COMMAND_MANAGER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Connection_Manager ( int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_CONNECTION_MANAGER_ADDR
    stx 2,y
    ldx #ETHER_CONNECTION_MANAGER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Service_Loop ( void )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SERVICE_LOOP_ADDR
    stx 2,y
    ldx #ETHER_SERVICE_LOOP_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Task_Setup ( TASK* task_base, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_TASK_SETUP_ADDR
    stx 2,y
    ldx #ETHER_TASK_SETUP_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void WiFi_Task_Setup ( TASK* task_base, int modulenum )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WIFI_TASK_SETUP_ADDR
    stx 2,y
    ldx #WIFI_TASK_SETUP_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Serial_Revector ( void )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_SERIAL_REVECTOR_ADDR
    stx 2,y
    ldx #ETHER_SERIAL_REVECTOR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Ether_Monitor ( void )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ETHER_MONITOR_ADDR
    stx 2,y
    ldx #ETHER_MONITOR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

// End of C Source file for package: EtherWiFi

// Beginning C Source file for package: GUI_Toolkit_QSC

_forth  void Update_Here_With( addr address,       addr * graphics_resource_addr,       page graphics_resource_page,       FORTH_ARRAY * garray_addr,       page garray_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #UPDATE_HERE_WITH_ADDR
    stx 2,y
    ldx #UPDATE_HERE_WITH_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Update_Graphics ( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #UPDATE_GRAPHICS_ADDR
    stx 2,y
    ldx #UPDATE_GRAPHICS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Update_Text( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #UPDATE_TEXT_ADDR
    stx 2,y
    ldx #UPDATE_TEXT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Update_Text_And_Graphics( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #UPDATE_TEXT_AND_GRAPHICS_ADDR
    stx 2,y
    ldx #UPDATE_TEXT_AND_GRAPHICS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Clear_Graphics( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #CLEAR_GRAPHICS_ADDR
    stx 2,y
    ldx #CLEAR_GRAPHICS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Clear_Text( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #CLEAR_TEXT_ADDR
    stx 2,y
    ldx #CLEAR_TEXT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Set_Text_Home_Addr( addr address )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SET_TEXT_HOME_ADDR_ADDR
    stx 2,y
    ldx #SET_TEXT_HOME_ADDR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Set_Gr_Home_Addr( addr address )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SET_GR_HOME_ADDR_ADDR
    stx 2,y
    ldx #SET_GR_HOME_ADDR_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Set_Text_Area( uint columns )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SET_TEXT_AREA_ADDR
    stx 2,y
    ldx #SET_TEXT_AREA_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Set_Gr_Area( uint columns )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SET_GR_AREA_ADDR
    stx 2,y
    ldx #SET_GR_AREA_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Set_Display_Mode( uint columns )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SET_DISPLAY_MODE_ADDR
    stx 2,y
    ldx #SET_DISPLAY_MODE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Set_Cursor_State( boolean isvisible, boolean isflashing )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SET_CURSOR_STATE_ADDR
    stx 2,y
    ldx #SET_CURSOR_STATE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Set_Display_State( boolean graphics, boolean text )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SET_DISPLAY_STATE_ADDR
    stx 2,y
    ldx #SET_DISPLAY_STATE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Set_Text_Mode( uchar modebyte )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SET_TEXT_MODE_ADDR
    stx 2,y
    ldx #SET_TEXT_MODE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Config_Display( uint graphics_cols, uint graphics_rows, addr graphics_start, uchar background_fill, uint text_cols, uint text_rows, addr text_start, xaddr heap_bottom, xaddr heap_top, GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #CONFIG_DISPLAY_ADDR
    stx 2,y
    ldx #CONFIG_DISPLAY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Init_Display( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #INIT_DISPLAY_ADDR
    stx 2,y
    ldx #INIT_DISPLAY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Std_Display( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #STD_DISPLAY_ADDR
    stx 2,y
    ldx #STD_DISPLAY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Draw_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #DRAW_GRAPHIC_ADDR
    stx 2,y
    ldx #DRAW_GRAPHIC_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Direct_Draw_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #DIRECT_DRAW_GRAPHIC_ADDR
    stx 2,y
    ldx #DIRECT_DRAW_GRAPHIC_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Direct_Erase_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #DIRECT_ERASE_GRAPHIC_ADDR
    stx 2,y
    ldx #DIRECT_ERASE_GRAPHIC_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Erase_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #ERASE_GRAPHIC_ADDR
    stx 2,y
    ldx #ERASE_GRAPHIC_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Do_Graphic ( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       uint action,       xaddr graphic_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #DO_GRAPHIC_ADDR
    stx 2,y
    ldx #DO_GRAPHIC_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Button_Draw_Textonly( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #BUTTON_DRAW_TEXTONLY_ADDR
    stx 2,y
    ldx #BUTTON_DRAW_TEXTONLY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Button_Draw( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #BUTTON_DRAW_ADDR
    stx 2,y
    ldx #BUTTON_DRAW_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Button_Erase_Textonly( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #BUTTON_ERASE_TEXTONLY_ADDR
    stx 2,y
    ldx #BUTTON_ERASE_TEXTONLY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Button_Erase( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #BUTTON_ERASE_ADDR
    stx 2,y
    ldx #BUTTON_ERASE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Button_Press( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #BUTTON_PRESS_ADDR
    stx 2,y
    ldx #BUTTON_PRESS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Button_Repeat( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #BUTTON_REPEAT_ADDR
    stx 2,y
    ldx #BUTTON_REPEAT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Button_Release( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #BUTTON_RELEASE_ADDR
    stx 2,y
    ldx #BUTTON_RELEASE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Do_Button( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       uint action,       BUTTON * button_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #DO_BUTTON_ADDR
    stx 2,y
    ldx #DO_BUTTON_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Do_Menu(   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   uint action,   MENU * menu_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #DO_MENU_ADDR
    stx 2,y
    ldx #DO_MENU_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Menu_Install( uint offset,   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   MENU *  menu_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #MENU_INSTALL_ADDR
    stx 2,y
    ldx #MENU_INSTALL_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Menu_Remove(   uint offset,   GUI_VARS * tvars_addr,   page tvars_page,   MENU *  menu_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #MENU_REMOVE_ADDR
    stx 2,y
    ldx #MENU_REMOVE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Init_Menu(   uint offset,   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   MENU * menu_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #INIT_MENU_ADDR
    stx 2,y
    ldx #INIT_MENU_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Uninit_Menu(   uint offset,   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   MENU * menu_addr )
{
#asm
    dey
    dey
    dey
    dey
    ldx #UNINIT_MENU_ADDR
    stx 2,y
    ldx #UNINIT_MENU_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Set_Pixel ( int x, int y )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SET_PIXEL_ADDR
    stx 2,y
    ldx #SET_PIXEL_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Clear_Pixel(int x, int y)
{
#asm
    dey
    dey
    dey
    dey
    ldx #CLEAR_PIXEL_ADDR
    stx 2,y
    ldx #CLEAR_PIXEL_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Is_Pressed ( void )
{
#asm
    dey
    dey
    dey
    dey
    ldx #IS_PRESSED_ADDR
    stx 2,y
    ldx #IS_PRESSED_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Wait_For_Press ( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WAIT_FOR_PRESS_ADDR
    stx 2,y
    ldx #WAIT_FOR_PRESS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Wait_For_Release ( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WAIT_FOR_RELEASE_ADDR
    stx 2,y
    ldx #WAIT_FOR_RELEASE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Read_Touchscreen ( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #READ_TOUCHSCREEN_ADDR
    stx 2,y
    ldx #READ_TOUCHSCREEN_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  long Read_Raw_Coords ( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #READ_RAW_COORDS_ADDR
    stx 2,y
    ldx #READ_RAW_COORDS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Calibrate_Touchscreen( long raw0, long raw1, long raw2 )
{
#asm
    dey
    dey
    dey
    dey
    ldx #CALIBRATE_TOUCHSCREEN_ADDR
    stx 2,y
    ldx #CALIBRATE_TOUCHSCREEN_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Globalize_TVars ( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #GLOBALIZE_TVARS_ADDR
    stx 2,y
    ldx #GLOBALIZE_TVARS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Screen_To_Image ( xaddr buffer, int buffer_size, int format )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SCREEN_TO_IMAGE_ADDR
    stx 2,y
    ldx #SCREEN_TO_IMAGE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Graphic_To_Image ( xaddr graphic, xaddr buffer, int buffer_size, int format )
{
#asm
    dey
    dey
    dey
    dey
    ldx #GRAPHIC_TO_IMAGE_ADDR
    stx 2,y
    ldx #GRAPHIC_TO_IMAGE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  long Simulate_Touch ( int x, int y )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SIMULATE_TOUCH_ADDR
    stx 2,y
    ldx #SIMULATE_TOUCH_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Screen_Has_Changed ( void )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SCREEN_HAS_CHANGED_ADDR
    stx 2,y
    ldx #SCREEN_HAS_CHANGED_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Has_Screen_Changed ( void )
{
#asm
    dey
    dey
    dey
    dey
    ldx #HAS_SCREEN_CHANGED_ADDR
    stx 2,y
    ldx #HAS_SCREEN_CHANGED_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  int Simulated_Touch_To_Image ( long buffer, int buffer_size, int format_id, int x, int y )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SIMULATED_TOUCH_TO_IMAGE_ADDR
    stx 2,y
    ldx #SIMULATED_TOUCH_TO_IMAGE_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Service_Touch( int buttonID, GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #SERVICE_TOUCH_ADDR
    stx 2,y
    ldx #SERVICE_TOUCH_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Menu_Process(  int buttonID, GUI_VARS * tvars_addr, page tvars_page)
{
#asm
    dey
    dey
    dey
    dey
    ldx #MENU_PROCESS_ADDR
    stx 2,y
    ldx #MENU_PROCESS_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Wait_Then_Service_Touch( GUI_VARS * tvars_addr, page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #WAIT_THEN_SERVICE_TOUCH_ADDR
    stx 2,y
    ldx #WAIT_THEN_SERVICE_TOUCH_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Menu_Query(   GUI_VARS * tvars_addr,   page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #MENU_QUERY_ADDR
    stx 2,y
    ldx #MENU_QUERY_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Init_Touch(   GUI_VARS * tvars_addr,   page tvars_page )
{
#asm
    dey
    dey
    dey
    dey
    ldx #INIT_TOUCH_ADDR
    stx 2,y
    ldx #INIT_TOUCH_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Render_Font_to_buffer(  char * string_addr, page string_page,       uint col,       uint row,       FORTH_ARRAY * garray_addr, page garray_page,       FONT * font_addr,       page font_page)
{
#asm
    dey
    dey
    dey
    dey
    ldx #RENDER_FONT_TO_BUFFER_ADDR
    stx 2,y
    ldx #RENDER_FONT_TO_BUFFER_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Render_Font(  char * string_addr, page string_page,       uint col,       uint row,       GUI_VARS * tvars_addr, page tvars_page,       FONT * font_addr,       page font_page)
{
#asm
    dey
    dey
    dey
    dey
    ldx #RENDER_FONT_ADDR
    stx 2,y
    ldx #RENDER_FONT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

_forth  void Direct_Render_Font( char * string_addr, page string_page,       uint col,       uint row,       GUI_VARS * tvars_addr,page tvars_page,       FONT * font_addr,       page font_page)
{
#asm
    dey
    dey
    dey
    dey
    ldx #DIRECT_RENDER_FONT_ADDR
    stx 2,y
    ldx #DIRECT_RENDER_FONT_PAGE
    stx 0,y
    bsr _forth?Execute
#endasm
}

// End of C Source file for package: GUI_Toolkit_QSC

// The following is a workaround to ensure that older versions of the Fabius
// compiler not complain about the use of the Execute function in #assm
// definitions.
void dummyfunction( )
  {
  // Never try to execute this function
  Execute(0xC412,0);    // This is just the address of a no op.  Do not execute
                        // this function.  It is just needed to cause the
                        // compiler to import the execute function.
  }


#pragma option warn=par
#pragma option warn=rvl

// *** Note: Be sure to #include this file in one of your source files
// and that library.h is #included before it.  Library.h should also
// be #included in any other source files that use any of the kernel
// extension functions.
